Subject: Re: SRV RR Questions

From: Paul Vixie <[email-masked]>
Date: Mon, 09 Dec 2002 22:08:32 +0000

Peter Koch <[email-masked]> writes:

> Randy Bush wrote:
> 
> > o as far as the protocol is concerned, names begining with _ are no
> >   more 'un-natural' than names begining with any other octet

i thought that war was over.  here's what joyce and --jon said:

> From: [email-masked]
> Date: Tue, 29 Oct 1996 12:58:18 -0800
> Posted-Date: Tue, 29 Oct 1996 12:58:18 -0800
> To: [email-masked]
> Subject: re: rfc-gulbrandsen-dns-rr-srvcs RFC-to-be
> Cc: [email-masked], [email-masked], [email-masked]
> 
> Folks,
> 
> Enclosed is a new version of the RFC-to-be, "A DNS RR for specifying
> the location of services (DNS SRV)".  We have removed the underbars.
> We would like to publish this out if there are no comments.  Please let
> us know if this is okay with you.
> 
> Thanks, Joyce and --jon.

naturally, i now wish i had been less strident in my arguments in favour
of the underbars -- mostly because the arguments about them and the flipping
back and forth and having them vs. not having them has cost SRV quite a bit
of deployment inertia.  here's what steve traugott said, two years later:

--------

To: Stuart Kwan <[email-masked]>
cc: "'Paul A Vixie'" <[email-masked]>, [email-masked]
Subject: Re: I-D ACTION:draft-ietf-dnsind-rfc2052bis-00.txt 
Date: Mon, 07 Sep 1998 01:06:03 -0600
From: Steve Traugott <[email-masked]>

That's silly, Stuart.  The omitted underscores were an editing mistake, the
spec is in experimental state so that these sorts of things can be caught,
and it was caught.  Paul is trying to fix something that is broke.  The 
reason is to avoid namespace collisions.  That makes it a better standard.
If you block this then Microsoft's name will be mud.  Don't you want Microsoft
to be known as a willing participant in enacting good standards instead?

I know some of the sensitivites of the Beta 2 release that you're trying 
to deal with; I was a technology vice president at Chase Manhattan Bank 
when Beta 1 came out; we were a participant.  I can tell you that as an IT
manager (i.e.; your customer) I'd much rather see Microsoft do the right
thing than take the expedient way out.  Breaking beta installs is a 
one-time-only thing that affects a relatively small user base; leaving 
this RFC broken permanently will give us consequences we will all have
to live with *forever*.

Steve

Stuart Kwan <[email-masked]> wrote: 
> Microsoft Windows NT 5.0 makes heavy use of the SRV RR, mainly for the
> location of Active Directory servers.  In the recently shipped Beta 2
> release of WinNT 5.0, Active Directory domain controllers use the dynamic
> update protocol to register SRV RRs.  Active Directory clients query for SRV
> RRs.  The current code uses RFC2052-spec names (no leading underscores).
> 
> WinNT 5.0 could be characterized as an "Early Adopter" of the (experimental)
> SRV RR.  To prevent future incompatibilites, we would prefer that the
> leading underscore not be reintroduced into the spec.
> 
> Cheers,
> - Stuart Kwan
> Microsoft Corp.
> 
> > -----Original Message-----
> > From:	Paul A Vixie [SMTP:[email-masked]]
> > Sent:	Wednesday, September 02, 1998 12:51 PM
> > To:	[email-masked]
> > Subject:	Re: I-D ACTION:draft-ietf-dnsind-rfc2052bis-00.txt 
> > 
> > > Could you summarize what the changes are and why they are being made?
> > > My quick scan of the new version didn't immediately pick up on
> > > anything, but I didn't do a detailed comparison.  I'm just sort of
> > > curious since I hadn't heard anything about doing a rev to RFC2052
> > > until the announcement came out.  I'd have thought at least a quick
> > > mention at Chicago given that DNSIND didn't use all its allotted
> > > time...
> > > 
> > > 	-MAP
> > 
> > The only difference is the putting back in of the _'s that the RFC Editor
> > took out of the draft I'd submitted for Experimental status.  To wit:
> > 
> > @@ -42,39 +52,42 @@
> >     (the word domain is used here in the strict RFC 1034 sense), and get
> >     back the names of any available servers.
> >  
> > -Introductory example
> >  
> > -   When a SRV-cognizant web-browser wants to retrieve
> >  
> > -      http://www.asdf.com/
> >  
> > -   it does a lookup of
> >  
> > -      http.tcp.www.asdf.com
> >  
> > +Introductory example
> >  
> > +   When a SRV-cognizant web-browser wants to retrieve
> >  
> > +      http://www.asdf.com/
> >  
> > +   it does a lookup of
> >  
> > +      _http._tcp.www.asdf.com
> >  
> >     and retrieves the document from one of the servers in the reply.  The
> > -   example zone file near the end of the memo contains answering RRs for
> > -   this query.
> > +   example zone file near the end of this memo contains answering RRs
> > +   for this query.
> > +
> >  
> >  The format of the SRV RR
> >  
> >     Here is the format of the SRV RR, whose DNS type code is 33:
> >  
> > -        Service.Proto.Name TTL Class SRV Priority Weight Port Target
> > +        _Service._Proto.Name TTL Class SRV Priority Weight Port Target
> >  
> >          (There is an example near the end of this document.)
> >  
> >     Service
> >          The symbolic name of the desired service, as defined in Assigned
> > -        Numbers or locally.
> > +        Numbers or locally.  An underscore (_) is prepended to the
> > +        service identifier to avoid collisions with DNS labels that
> > +        occur in nature.
> >  
> >          Some widely used services, notably POP, don't have a single
> >          universal name.  If Assigned Numbers names the service
> > @@ -83,7 +96,9 @@
> >          The Service is case insensitive.
> >  
> >     Proto
> > -        TCP and UDP are at present the most useful values
> > +        The symbolic name of the desired protocol, with an underscore
> > +        (_) prepended to prevent collisions with DNS labels that occur
> > +        in nature.  _TCP and _UDP are at present the most useful values
> >          for this field, though any name defined by Assigned Numbers or
> >          locally may be used (as for Service).  The Proto is case
> >          insensitive.
> > @@ -182,31 +194,40 @@
> >  
> >     All round numbers, wrote Dr. Johnson, are false, and these numbers
> >     are very round: A reply packet has a 30-byte overhead plus the name
> > -   of the service ("telnet.tcp.asdf.com" for instance); each SRV RR adds
> > -   20 bytes plus the name of the target host; each NS RR in the NS
> > +   of the service (``_telnet._tcp.asdf.com'' for instance); each SRV RR
> > +   adds 20 bytes plus the name of the target host; each NS RR in the NS
> >     section is 15 bytes plus the name of the name server host; and
> >     finally each A RR in the additional data section is 20 bytes or so,
> >     and there are A's for each SRV and NS RR mentioned in the answer.
> > @@ -233,14 +244,14 @@
> >     A SRV-cognizant client SHOULD use this procedure to locate a list of
> >     servers and connect to the preferred one:
> >  
> > -        Do a lookup for QNAME=service.protocol.target, QCLASS=IN,
> > +        Do a lookup for QNAME=_service._protocol.target, QCLASS=IN,
> >          QTYPE=SRV.
> >  
> >          If the reply is NOERROR, ANCOUNT>0 and there is at least one SRV
> >          RR which specifies the requested Service and Protocol in the
> >          reply:
> >  
> >               If there is precisely one SRV RR, and its Target is "."
> >               (the root domain), abort.
> >  
> >               Else, for all such RR's, build a list of (Priority, Weight,
> > @@ -308,7 +364,7 @@
> >          or NS RR's.)
> >  
> >        - A future standard could specify that a SRV RR whose Protocol was
> > -        TCP and whose Service was SMTP would override RFC 974's rules
> > +        _TCP and whose Service was _SMTP would override RFC 974's rules
> >          with regard to the use of an MX RR.  This would allow firewalled
> >          organizations with several SMTP relays to control the load
> >          distribution using the Weight field.
> > @@ -316,6 +372,7 @@
> >        - Future protocols could be designed to use SRV RR lookups as the
> >          means by which clients locate their servers.
> >  
> > +
> >  Fictional example
> >  
> >     This is (part of) the zone file for asdf.com, a still-unused domain:
> > @@ -326,20 +383,20 @@
> >                          NS  server.asdf.com.
> >                          NS  ns1.ip-provider.net.
> >                          NS  ns2.ip-provider.net.
> > -        ftp.tcp         SRV 0 0 21 server.asdf.com.
> > -        finger.tcp      SRV 0 0 79 server.asdf.com.
> > +        _ftp._tcp       SRV 0 0 21 server.asdf.com.
> > +        _finger._tcp    SRV 0 0 79 server.asdf.com.
> >          ; telnet - use old-slow-box or new-fast-box if either is
> >          ; available, make three quarters of the logins go to
> >          ; new-fast-box.
> > -        telnet.tcp      SRV 0 1 23 old-slow-box.asdf.com.
> >  
> >  
> >  
> > -Gulbrandsen & Vixie           Experimental                      [Page 6]
> > +Gulbrandsen and Vixie           Proposed                        [Page 7]
> >  
> > -RFC 2052                       DNS SRV RR                   October 1996
> > +RFC 2052bis                    DNS SRV RR                 September 1998
> >  
> >  
> > +        _telnet._tcp    SRV 0 1 23 old-slow-box.asdf.com.
> >                          SRV 0 3 23 new-fast-box.asdf.com.
> >          ; if neither old-slow-box or new-fast-box is up, switch to
> >          ; using the sysdmin's box and the server
> > @@ -347,22 +404,22 @@
> >                          SRV 1 0 23 server.asdf.com.
> >          ; HTTP - server is the main server, new-fast-box is the backup
> >          ; (On new-fast-box, the HTTP daemon runs on port 8000)
> > -        http.tcp        SRV 0 0 80 server.asdf.com.
> > +        _http._tcp      SRV 0 0 80 server.asdf.com.
> >                          SRV 10 0 8000 new-fast-box.asdf.com.
> >          ; since we want to support both http://asdf.com/ and
> >          ; http://www.asdf.com/ we need the next two RRs as well
> > -        http.tcp.www    SRV 0 0 80 server.asdf.com.
> > +        _http._tcp.www  SRV 0 0 80 server.asdf.com.
> >                          SRV 10 0 8000 new-fast-box.asdf.com.
> >          ; SMTP - mail goes to the server, and to the IP provider if
> >          ; the net is down
> > -        smtp.tcp        SRV 0 0 25 server.asdf.com.
> > +        _smtp._tcp      SRV 0 0 25 server.asdf.com.
> >                          SRV 1 0 25 mailhost.ip-provider.net.
> >          @               MX  0 server.asdf.com.
> >                          MX  1 mailhost.ip-provider.net.
> >          ; NNTP - use the IP providers's NNTP server
> > -        nntp.tcp        SRV 0 0 119 nntphost.ip-provider.net.
> > +        _nntp._tcp      SRV 0 0 119 nntphost.ip-provider.net.
> >          ; IDB is an locally defined protocol
> > -        idb.tcp         SRV  0 0 2025 new-fast-box.asdf.com.
> > +        _idb._tcp SRV  0 0 2025 new-fast-box.asdf.com.
> >          ; addresses
> >          server          A   172.30.79.10
> >          old-slow-box    A   172.30.79.11
> > @@ -377,98 +434,42 @@
> >          ; backup A RR for www.asdf.com
> >          www             A       172.30.79.10
> >          ; NO other services are supported
> > -        *.tcp           SRV  0 0 0 .
> > -        *.udp           SRV  0 0 0 .
> > +        *._tcp         SRV  0 0 0 .
> > +        *._udp         SRV  0 0 0 .
> >  
> > -   In this example, a telnet connection to "asdf.com." needs an SRV
> > -   lookup of "telnet.tcp.asdf.com." and possibly A lookups of "new-
> > -   fast-box.asdf.com." and/or the other hosts named.  The size of the
> > +   In this example, a telnet connection to ``asdf.com.'' needs an SRV
> > +   lookup of ``_telnet._tcp.asdf.com.'' and possibly A lookups of ``new-
> > +   fast-box.asdf.com.'' and/or the other hosts named.  The size of the
> >     SRV reply is approximately 365 bytes:
> >  
> >        30 bytes general overhead
> > -      20 bytes for the query string, "telnet.tcp.asdf.com."
> > -      130 bytes for 4 SRV RR's, 20 bytes each plus the lengths of "new-
> > +      20 bytes for the query string, ``_telnet._tcp.asdf.com.''
> >  
> >  
> >  
> > -Gulbrandsen & Vixie           Experimental                      [Page 7]
> > +Gulbrandsen and Vixie           Proposed                        [Page 8]
> >  
> > -RFC 2052                       DNS SRV RR                   October 1996
> > +RFC 2052bis                    DNS SRV RR                 September 1998
> >  
> >  
> > -        fast-box", "old-slow-box", "server" and "sysadmins-box" -
> > -        "asdf.com" in the query section is quoted here and doesn't
> > +      130 bytes for 4 SRV RR's, 20 bytes each plus the lengths of ``new-
> > +        fast-box'', ``old-slow-box'', ``server'' and ``sysadmins-box'' -
> > +        ``asdf.com'' in the query section is quoted here and doesn't
> >          need to be counted again.
> >        75 bytes for 3 NS RRs, 15 bytes each plus the lengths of
> > -        "server", "ns1.ip-provider.net." and "ns2" - again, "ip-
> > -        provider.net." is quoted and only needs to be counted once.
> > +        ``server'', ``ns1.ip-provider.net.'' and ``ns2'' - again, ``ip-
> > +        provider.net.'' is quoted and only needs to be counted once.
> >        120 bytes for the 6 A RR's mentioned by the SRV and NS RR's.
> >  
> > -Refererences
> > -
> > -   RFC 1918: Rekhter, Y., Moskowitz, R., Karrenberg, D., de Groot, G.,
> > -        and E.  Lear, "Address Allocation for Private Internets",
> > -        RFC 1918, February 1996.
> > -
> > -   RFC 1916 Berkowitz, H., Ferguson, P, Leland, W. and P. Nesser,
> > -        "Enterprise Renumbering: Experience and Information
> > -        Solicitation", RFC 1916, February 1996.
> > -
> > -   RFC 1912 Barr, D., "Common DNS Operational and Configuration
> > -        Errors", RFC 1912, February 1996.
> > -
> > -   RFC 1900: Carpenter, B., and Y. Rekhter, "Renumbering Needs Work",
> > -        RFC 1900, February 1996.
> > -
> > -   RFC 1920: Postel, J., "INTERNET OFFICIAL PROTOCOL STANDARDS",
> > -        STD 1, RFC 1920, March 1996.
> >  
> > -   RFC 1814: Gerich, E., "Unique Addresses are Good", RFC 1814, June
> > -             1995.
> > -
> > -   RFC 1794: Brisco, T., "DNS Support for Load Balancing", April 1995.
> > -
> > -   RFC 1713: Romao, A., "Tools for DNS debugging", November 1994.
> > -
> > -   RFC 1712: Farrell, C., Schulze, M., Pleitner, S., and D. Baldoni,
> > -        "DNS Encoding of Geographical Location", RFC 1712, November
> > -        1994.
> > -
> > -   RFC 1706: Manning, B. and R. Colella, "DNS NSAP Resource Records",
> > -        RFC 1706, October 1994.
> > -
> > -   RFC 1700: Reynolds, J., and J. Postel, "ASSIGNED NUMBERS",
> > -        STD 2, RFC 1700, October 1994.
> > -
> > -   RFC 1183: Ullmann, R., Mockapetris, P., Mamakos, L., and
> > -        C. Everhart, "New DNS RR Definitions", RFC 1183, November
> > -        1990.
> > -
> > -
> > -
> > -
> > -Gulbrandsen & Vixie           Experimental                      [Page 8]
> > -
> > -RFC 2052                       DNS SRV RR                   October 1996
> > -
> > -
> > -   RFC 1101: Mockapetris, P., "DNS encoding of network names and other
> > -        types", RFC 1101, April 1989.
> > -
> > -   RFC 1035: Mockapetris, P., "Domain names - implementation and
> > -        specification", STD 13, RFC 1035, November 1987.
> > -
> > -   RFC 1034: Mockapetris, P., "Domain names - concepts and
> > -        facilities", STD 13, RFC 1034, November 1987.
> > +Refererences
> >  
> > -   RFC 1033: Lottor, M., "Domain administrators operations guide",
> > -        RFC 1033, November 1987.
> > +   RFC 1034: Mockapetris, P., ``Domain names - concepts and
> > +        facilities'', RFC 1034, November 1987.
> >  
> > -   RFC 1032: Stahl, M., "Domain administrators guide", RFC 1032,
> > -        November 1987.
> > +   RFC 974: Partridge, C., ``Mail routing and the domain system'', RFC
> > +        974, January 1986.
> >  
> > -   RFC 974: Partridge, C., "Mail routing and the domain system",
> > -        STD 14, RFC 974, January 1986.
> >  
> >  Security Considerations
> >  
> > @@ -490,74 +491,17 @@
> >          host names and addresses.  The authors do not see any practical
> >          effect of this.
> >  
> > -   We assume that as the DNS-security people invent new features, DNS
> > -   servers will return the relevant RRs in the Additional Data section
> > -   when answering an SRV query.
> > -
> > -
> > -
> > -
> > -
> > -
> > -
> > -
> > -
> > -
> > -Gulbrandsen & Vixie           Experimental                      [Page 9]
> > -
> > -RFC 2052                       DNS SRV RR                   October 1996
> > -
> > -
> >  Authors' Addresses
> >  
> > -   Arnt Gulbrandsen
> > -   Troll Tech
> > -   Postboks 6133 Etterstad
> > -   N-0602 Oslo
> > -   Norway
> > -
> > -   Phone: +47 22646966
> > -   EMail: [email-masked]
> > -
> > -
> > -   Paul Vixie
> > -   Vixie Enterprises
> > -   Star Route 159A
> > -   Woodside, CA  94062
> > -
> > -   Phone: (415) 747-0204
> > -   EMail: [email-masked]
> > -
> > -
> > -
> > -
> > -
> > -
> > -
> > -
> > -
> > +   Arnt Gulbrandsen              Paul Vixie
> > +      Troll Tech                    Internet Software Consortium
> > +      Postboks 6133 Etterstad            950 Charter Street
> > +      N-0602 Oslo, Norway                Redwood City, CA 94063
> > +      +47 22646966                       +1 650 779 7001
> > +      <[email-masked]>                 <[email-masked]>
> >  
> >  
> >  
> >  
> > -
> > -
> > -
> > -
> > -
> > -
> > -
> > -
> > -
> > -
> > -
> > -
> > -
> > -
> > -
> > -
> > -
> > -
> > -
> > -Gulbrandsen & Vixie           Experimental                     [Page 10]
> > -
> > +Gulbrandsen and Vixie           Proposed                        [Page 9]
> > +
> > \ No newline at end of file

--------

-- 
Paul Vixie

--
to unsubscribe send a message to [email-masked] with
the word 'unsubscribe' in a single line as the message text body.
archive: <http://ops.ietf.org/lists/namedroppers/>

---

From: "Hallam-Baker, Phillip" <[email-masked]>
Date: Mon, 9 Dec 2002 15:50:35 -0800

In like vein there is a LOT of current interest in using SRV to locate
XKMS services and other PKI services.

I just want a character string to serve as an index term for an XKMS
service, I don't give a hoot what it is, but if the group cannot decide
what it should be quickly I will simply let the current draft go out
with its own idea of what the string should be.

This is a naming issue. It does not matter what the group chooses but
there is a strictly limited time to make the choice.

At present the draft specifies:

_xkiss_soap_http._tcp
_xkiss_soap_http._tcp

There is an aligned PKIX draft with LDAP entries:

_pkix_ldap._tcp

To which it has been suggested that we add:

_dpd_http._tcp
_dpv_http._tcp
_ocsp_http._tcp
_cmp_http._tcp

Donald Eastlake has suggested an alternative encoding for the higher
level services :

_xkms-xkiss-soap._http._tcp

I really don't care what the name structure that is chosen is. But I do
care that there is a choice made.

		Phill